Index: linux-kj/drivers/scsi/FlashPoint.c
===================================================================
--- linux-kj.orig/drivers/scsi/FlashPoint.c	2005-12-05 13:19:06.000000000 +0300
+++ linux-kj/drivers/scsi/FlashPoint.c	2005-12-05 13:19:06.000000000 +0300
@@ -4937,201 +4669,259 @@ static void FPT_autoLoadDefaultMap(unsig
 
 static void FPT_autoCmdCmplt(unsigned long p_port, unsigned char p_card)
 {
-   struct sccb * currSCCB;
-   unsigned char status_byte;
-
-   currSCCB = FPT_BL_Card[p_card].currentSCCB;
+	struct sccb *currSCCB;
+	unsigned char status_byte;
 
-   status_byte = RD_HARPOON(p_port+hp_gp_reg_0);
+	currSCCB = FPT_BL_Card[p_card].currentSCCB;
 
-   FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarLUN_CA = 0;
+	status_byte = RD_HARPOON(p_port + hp_gp_reg_0);
 
-   if (status_byte != SSGOOD) {
+	FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarLUN_CA = 0;
 
-      if (status_byte == SSQ_FULL) {
+	if (status_byte != SSGOOD) {
 
+		if (status_byte == SSQ_FULL) {
 
-			if(((FPT_BL_Card[p_card].globalFlags & F_CONLUN_IO) &&
-				((FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarStatus & TAR_TAG_Q_MASK) != TAG_Q_TRYING)))
-			{
-	         FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarLUNBusy[currSCCB->Lun] = 1;
-				if(FPT_BL_Card[p_card].discQCount != 0)
+			if (((FPT_BL_Card[p_card].globalFlags & F_CONLUN_IO) &&
+			     ((FPT_sccbMgrTbl[p_card][currSCCB->TargID].
+			       TarStatus & TAR_TAG_Q_MASK) != TAG_Q_TRYING))) {
+				FPT_sccbMgrTbl[p_card][currSCCB->TargID].
+				    TarLUNBusy[currSCCB->Lun] = 1;
+				if (FPT_BL_Card[p_card].discQCount != 0)
 					FPT_BL_Card[p_card].discQCount--;
-				FPT_BL_Card[p_card].discQ_Tbl[FPT_sccbMgrTbl[p_card][currSCCB->TargID].LunDiscQ_Idx[currSCCB->Lun]] = NULL;
-			}
-			else
-			{
-	         FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarLUNBusy[0] = 1;
-				if(currSCCB->Sccb_tag)
-				{
-					if(FPT_BL_Card[p_card].discQCount != 0)
-						FPT_BL_Card[p_card].discQCount--;
-					FPT_BL_Card[p_card].discQ_Tbl[currSCCB->Sccb_tag] = NULL;
-				}else
-				{
-					if(FPT_BL_Card[p_card].discQCount != 0)
-						FPT_BL_Card[p_card].discQCount--;
-					FPT_BL_Card[p_card].discQ_Tbl[FPT_sccbMgrTbl[p_card][currSCCB->TargID].LunDiscQ_Idx[0]] = NULL;
+				FPT_BL_Card[p_card].
+				    discQ_Tbl[FPT_sccbMgrTbl[p_card]
+					      [currSCCB->TargID].
+					      LunDiscQ_Idx[currSCCB->Lun]] =
+				    NULL;
+			} else {
+				FPT_sccbMgrTbl[p_card][currSCCB->TargID].
+				    TarLUNBusy[0] = 1;
+				if (currSCCB->Sccb_tag) {
+					if (FPT_BL_Card[p_card].discQCount != 0)
+						FPT_BL_Card[p_card].
+						    discQCount--;
+					FPT_BL_Card[p_card].discQ_Tbl[currSCCB->
+								      Sccb_tag]
+					    = NULL;
+				} else {
+					if (FPT_BL_Card[p_card].discQCount != 0)
+						FPT_BL_Card[p_card].
+						    discQCount--;
+					FPT_BL_Card[p_card].
+					    discQ_Tbl[FPT_sccbMgrTbl[p_card]
+						      [currSCCB->TargID].
+						      LunDiscQ_Idx[0]] = NULL;
 				}
 			}
 
-         currSCCB->Sccb_MGRFlags |= F_STATUSLOADED;
-
-         FPT_queueSelectFail(&FPT_BL_Card[p_card],p_card);
-
-         return;
-         }
+			currSCCB->Sccb_MGRFlags |= F_STATUSLOADED;
 
-      if(currSCCB->Sccb_scsistat == SELECT_SN_ST)
-         {
-         FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarStatus |=
-            (unsigned char)SYNC_SUPPORTED;
+			FPT_queueSelectFail(&FPT_BL_Card[p_card], p_card);
 
-	      FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarEEValue &= ~EE_SYNC_MASK;
-         FPT_BL_Card[p_card].globalFlags |= F_NEW_SCCB_CMD;
+			return;
+		}
 
-			if(((FPT_BL_Card[p_card].globalFlags & F_CONLUN_IO) &&
-				((FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarStatus & TAR_TAG_Q_MASK) != TAG_Q_TRYING)))
-			{
-	         FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarLUNBusy[currSCCB->Lun] = 1;
-				if(FPT_BL_Card[p_card].discQCount != 0)
+		if (currSCCB->Sccb_scsistat == SELECT_SN_ST) {
+			FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarStatus |=
+			    (unsigned char)SYNC_SUPPORTED;
+
+			FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarEEValue &=
+			    ~EE_SYNC_MASK;
+			FPT_BL_Card[p_card].globalFlags |= F_NEW_SCCB_CMD;
+
+			if (((FPT_BL_Card[p_card].globalFlags & F_CONLUN_IO) &&
+			     ((FPT_sccbMgrTbl[p_card][currSCCB->TargID].
+			       TarStatus & TAR_TAG_Q_MASK) != TAG_Q_TRYING))) {
+				FPT_sccbMgrTbl[p_card][currSCCB->TargID].
+				    TarLUNBusy[currSCCB->Lun] = 1;
+				if (FPT_BL_Card[p_card].discQCount != 0)
 					FPT_BL_Card[p_card].discQCount--;
-				FPT_BL_Card[p_card].discQ_Tbl[FPT_sccbMgrTbl[p_card][currSCCB->TargID].LunDiscQ_Idx[currSCCB->Lun]] = NULL;
-			}
-			else
-			{
-	         FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarLUNBusy[0] = 1;
-				if(currSCCB->Sccb_tag)
-				{
-					if(FPT_BL_Card[p_card].discQCount != 0)
-						FPT_BL_Card[p_card].discQCount--;
-					FPT_BL_Card[p_card].discQ_Tbl[currSCCB->Sccb_tag] = NULL;
-				}else
-				{
-					if(FPT_BL_Card[p_card].discQCount != 0)
-						FPT_BL_Card[p_card].discQCount--;
-					FPT_BL_Card[p_card].discQ_Tbl[FPT_sccbMgrTbl[p_card][currSCCB->TargID].LunDiscQ_Idx[0]] = NULL;
+				FPT_BL_Card[p_card].
+				    discQ_Tbl[FPT_sccbMgrTbl[p_card]
+					      [currSCCB->TargID].
+					      LunDiscQ_Idx[currSCCB->Lun]] =
+				    NULL;
+			} else {
+				FPT_sccbMgrTbl[p_card][currSCCB->TargID].
+				    TarLUNBusy[0] = 1;
+				if (currSCCB->Sccb_tag) {
+					if (FPT_BL_Card[p_card].discQCount != 0)
+						FPT_BL_Card[p_card].
+						    discQCount--;
+					FPT_BL_Card[p_card].discQ_Tbl[currSCCB->
+								      Sccb_tag]
+					    = NULL;
+				} else {
+					if (FPT_BL_Card[p_card].discQCount != 0)
+						FPT_BL_Card[p_card].
+						    discQCount--;
+					FPT_BL_Card[p_card].
+					    discQ_Tbl[FPT_sccbMgrTbl[p_card]
+						      [currSCCB->TargID].
+						      LunDiscQ_Idx[0]] = NULL;
 				}
 			}
-         return;
-
-         }
-
-      if(currSCCB->Sccb_scsistat == SELECT_WN_ST)
-         {
+			return;
 
-	      FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarStatus =
-	         (FPT_sccbMgrTbl[p_card][currSCCB->TargID].
-	         TarStatus & ~WIDE_ENABLED) | WIDE_NEGOCIATED;
+		}
 
-	      FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarEEValue &= ~EE_WIDE_SCSI;
-         FPT_BL_Card[p_card].globalFlags |= F_NEW_SCCB_CMD;
+		if (currSCCB->Sccb_scsistat == SELECT_WN_ST) {
 
-			if(((FPT_BL_Card[p_card].globalFlags & F_CONLUN_IO) &&
-				((FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarStatus & TAR_TAG_Q_MASK) != TAG_Q_TRYING)))
-			{
-	         FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarLUNBusy[currSCCB->Lun] = 1;
-				if(FPT_BL_Card[p_card].discQCount != 0)
+			FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarStatus =
+			    (FPT_sccbMgrTbl[p_card][currSCCB->TargID].
+			     TarStatus & ~WIDE_ENABLED) | WIDE_NEGOCIATED;
+
+			FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarEEValue &=
+			    ~EE_WIDE_SCSI;
+			FPT_BL_Card[p_card].globalFlags |= F_NEW_SCCB_CMD;
+
+			if (((FPT_BL_Card[p_card].globalFlags & F_CONLUN_IO) &&
+			     ((FPT_sccbMgrTbl[p_card][currSCCB->TargID].
+			       TarStatus & TAR_TAG_Q_MASK) != TAG_Q_TRYING))) {
+				FPT_sccbMgrTbl[p_card][currSCCB->TargID].
+				    TarLUNBusy[currSCCB->Lun] = 1;
+				if (FPT_BL_Card[p_card].discQCount != 0)
 					FPT_BL_Card[p_card].discQCount--;
-				FPT_BL_Card[p_card].discQ_Tbl[FPT_sccbMgrTbl[p_card][currSCCB->TargID].LunDiscQ_Idx[currSCCB->Lun]] = NULL;
-			}
-			else
-			{
-	         FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarLUNBusy[0] = 1;
-				if(currSCCB->Sccb_tag)
-				{
-					if(FPT_BL_Card[p_card].discQCount != 0)
-						FPT_BL_Card[p_card].discQCount--;
-					FPT_BL_Card[p_card].discQ_Tbl[currSCCB->Sccb_tag] = NULL;
-				}else
-				{
-					if(FPT_BL_Card[p_card].discQCount != 0)
-						FPT_BL_Card[p_card].discQCount--;
-					FPT_BL_Card[p_card].discQ_Tbl[FPT_sccbMgrTbl[p_card][currSCCB->TargID].LunDiscQ_Idx[0]] = NULL;
+				FPT_BL_Card[p_card].
+				    discQ_Tbl[FPT_sccbMgrTbl[p_card]
+					      [currSCCB->TargID].
+					      LunDiscQ_Idx[currSCCB->Lun]] =
+				    NULL;
+			} else {
+				FPT_sccbMgrTbl[p_card][currSCCB->TargID].
+				    TarLUNBusy[0] = 1;
+				if (currSCCB->Sccb_tag) {
+					if (FPT_BL_Card[p_card].discQCount != 0)
+						FPT_BL_Card[p_card].
+						    discQCount--;
+					FPT_BL_Card[p_card].discQ_Tbl[currSCCB->
+								      Sccb_tag]
+					    = NULL;
+				} else {
+					if (FPT_BL_Card[p_card].discQCount != 0)
+						FPT_BL_Card[p_card].
+						    discQCount--;
+					FPT_BL_Card[p_card].
+					    discQ_Tbl[FPT_sccbMgrTbl[p_card]
+						      [currSCCB->TargID].
+						      LunDiscQ_Idx[0]] = NULL;
 				}
 			}
-         return;
-      
-         }
-     
-	   if (status_byte == SSCHECK) 
-		{
-			if(FPT_BL_Card[p_card].globalFlags & F_DO_RENEGO)
-			{
-				if (FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarEEValue & EE_SYNC_MASK)
-				{
-					FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarStatus &= ~TAR_SYNC_MASK;
+			return;
+
+		}
+
+		if (status_byte == SSCHECK) {
+			if (FPT_BL_Card[p_card].globalFlags & F_DO_RENEGO) {
+				if (FPT_sccbMgrTbl[p_card][currSCCB->TargID].
+				    TarEEValue & EE_SYNC_MASK) {
+					FPT_sccbMgrTbl[p_card][currSCCB->
+							       TargID].
+					    TarStatus &= ~TAR_SYNC_MASK;
 				}
-				if (FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarEEValue & EE_WIDE_SCSI)
-				{
-					FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarStatus &= ~TAR_WIDE_MASK;
+				if (FPT_sccbMgrTbl[p_card][currSCCB->TargID].
+				    TarEEValue & EE_WIDE_SCSI) {
+					FPT_sccbMgrTbl[p_card][currSCCB->
+							       TargID].
+					    TarStatus &= ~TAR_WIDE_MASK;
 				}
 			}
 		}
 
-      if (!(currSCCB->Sccb_XferState & F_AUTO_SENSE)) {
+		if (!(currSCCB->Sccb_XferState & F_AUTO_SENSE)) {
 
-         currSCCB->SccbStatus = SCCB_ERROR;
-         currSCCB->TargetStatus = status_byte;
+			currSCCB->SccbStatus = SCCB_ERROR;
+			currSCCB->TargetStatus = status_byte;
 
-         if (status_byte == SSCHECK) {
+			if (status_byte == SSCHECK) {
 
-            FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarLUN_CA
-               = 1;
-     
-
-            if (currSCCB->RequestSenseLength != NO_AUTO_REQUEST_SENSE) {
-
-               if (currSCCB->RequestSenseLength == 0)
-                  currSCCB->RequestSenseLength = 14;
-
-               FPT_ssenss(&FPT_BL_Card[p_card]);
-               FPT_BL_Card[p_card].globalFlags |= F_NEW_SCCB_CMD;
-
- 					if(((FPT_BL_Card[p_card].globalFlags & F_CONLUN_IO) &&
-						((FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarStatus & TAR_TAG_Q_MASK) != TAG_Q_TRYING)))
-					{
-			         FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarLUNBusy[currSCCB->Lun] = 1;
-						if(FPT_BL_Card[p_card].discQCount != 0)
-							FPT_BL_Card[p_card].discQCount--;
-						FPT_BL_Card[p_card].discQ_Tbl[FPT_sccbMgrTbl[p_card][currSCCB->TargID].LunDiscQ_Idx[currSCCB->Lun]] = NULL;
-					}
-					else
-					{
-	   		      FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarLUNBusy[0] = 1;
-						if(currSCCB->Sccb_tag)
-						{
-							if(FPT_BL_Card[p_card].discQCount != 0)
-								FPT_BL_Card[p_card].discQCount--;
-							FPT_BL_Card[p_card].discQ_Tbl[currSCCB->Sccb_tag] = NULL;
-						}else
-						{
-							if(FPT_BL_Card[p_card].discQCount != 0)
-								FPT_BL_Card[p_card].discQCount--;
-							FPT_BL_Card[p_card].discQ_Tbl[FPT_sccbMgrTbl[p_card][currSCCB->TargID].LunDiscQ_Idx[0]] = NULL;
+				FPT_sccbMgrTbl[p_card][currSCCB->TargID].
+				    TarLUN_CA = 1;
+
+				if (currSCCB->RequestSenseLength !=
+				    NO_AUTO_REQUEST_SENSE) {
+
+					if (currSCCB->RequestSenseLength == 0)
+						currSCCB->RequestSenseLength =
+						    14;
+
+					FPT_ssenss(&FPT_BL_Card[p_card]);
+					FPT_BL_Card[p_card].globalFlags |=
+					    F_NEW_SCCB_CMD;
+
+					if (((FPT_BL_Card[p_card].
+					      globalFlags & F_CONLUN_IO)
+					     &&
+					     ((FPT_sccbMgrTbl[p_card]
+					       [currSCCB->TargID].
+					       TarStatus & TAR_TAG_Q_MASK) !=
+					      TAG_Q_TRYING))) {
+						FPT_sccbMgrTbl[p_card]
+						    [currSCCB->TargID].
+						    TarLUNBusy[currSCCB->Lun] =
+						    1;
+						if (FPT_BL_Card[p_card].
+						    discQCount != 0)
+							FPT_BL_Card[p_card].
+							    discQCount--;
+						FPT_BL_Card[p_card].
+						    discQ_Tbl[FPT_sccbMgrTbl
+							      [p_card]
+							      [currSCCB->
+							       TargID].
+							      LunDiscQ_Idx
+							      [currSCCB->Lun]] =
+						    NULL;
+					} else {
+						FPT_sccbMgrTbl[p_card]
+						    [currSCCB->TargID].
+						    TarLUNBusy[0] = 1;
+						if (currSCCB->Sccb_tag) {
+							if (FPT_BL_Card[p_card].
+							    discQCount != 0)
+								FPT_BL_Card
+								    [p_card].
+								    discQCount--;
+							FPT_BL_Card[p_card].
+							    discQ_Tbl[currSCCB->
+								      Sccb_tag]
+							    = NULL;
+						} else {
+							if (FPT_BL_Card[p_card].
+							    discQCount != 0)
+								FPT_BL_Card
+								    [p_card].
+								    discQCount--;
+							FPT_BL_Card[p_card].
+							    discQ_Tbl
+							    [FPT_sccbMgrTbl
+							     [p_card][currSCCB->
+								      TargID].
+							     LunDiscQ_Idx[0]] =
+							    NULL;
 						}
 					}
-               return;
-               }
-            }
-         }
-      }
-
+					return;
+				}
+			}
+		}
+	}
 
-	if((FPT_BL_Card[p_card].globalFlags & F_CONLUN_IO) &&
-		((FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarStatus & TAR_TAG_Q_MASK) != TAG_Q_TRYING))
-	   FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarLUNBusy[currSCCB->Lun] = 0;
+	if ((FPT_BL_Card[p_card].globalFlags & F_CONLUN_IO) &&
+	    ((FPT_sccbMgrTbl[p_card][currSCCB->TargID].
+	      TarStatus & TAR_TAG_Q_MASK) != TAG_Q_TRYING))
+		FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarLUNBusy[currSCCB->
+								    Lun] = 0;
 	else
-	   FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarLUNBusy[0] = 0;
-
+		FPT_sccbMgrTbl[p_card][currSCCB->TargID].TarLUNBusy[0] = 0;
 
-   FPT_queueCmdComplete(&FPT_BL_Card[p_card], currSCCB, p_card);
+	FPT_queueCmdComplete(&FPT_BL_Card[p_card], currSCCB, p_card);
 }
 
 #define SHORT_WAIT   0x0000000F
 #define LONG_WAIT    0x0000FFFFL
 
-
 /*---------------------------------------------------------------------
  *
  * Function: Data Transfer Processor
@@ -5150,37 +4940,33 @@ static void FPT_autoCmdCmplt(unsigned lo
  *              
  *---------------------------------------------------------------------*/
 
-static void FPT_dataXferProcessor(unsigned long port, struct sccb_card * pCurrCard)
+static void FPT_dataXferProcessor(unsigned long port,
+				  struct sccb_card *pCurrCard)
 {
-   struct sccb * currSCCB;
+	struct sccb *currSCCB;
 
-   currSCCB = pCurrCard->currentSCCB;
+	currSCCB = pCurrCard->currentSCCB;
 
-      if (currSCCB->Sccb_XferState & F_SG_XFER)
-			{
-			if (pCurrCard->globalFlags & F_HOST_XFER_ACT)
+	if (currSCCB->Sccb_XferState & F_SG_XFER) {
+		if (pCurrCard->globalFlags & F_HOST_XFER_ACT)
+		{
+			currSCCB->Sccb_sgseg += (unsigned char)SG_BUF_CNT;
+			currSCCB->Sccb_SGoffset = 0x00;
+		}
+		pCurrCard->globalFlags |= F_HOST_XFER_ACT;
 
-				{
-		   	currSCCB->Sccb_sgseg += (unsigned char)SG_BUF_CNT;
-         	currSCCB->Sccb_SGoffset = 0x00; 
- 				}
+		FPT_busMstrSGDataXferStart(port, currSCCB);
+	}
+
+	else {
+		if (!(pCurrCard->globalFlags & F_HOST_XFER_ACT)) {
 			pCurrCard->globalFlags |= F_HOST_XFER_ACT;
-         
-         FPT_busMstrSGDataXferStart(port, currSCCB);
-			}
 
-      else
-			{
-			if (!(pCurrCard->globalFlags & F_HOST_XFER_ACT))
-				{
-				pCurrCard->globalFlags |= F_HOST_XFER_ACT;
-         
-         	FPT_busMstrDataXferStart(port, currSCCB);
-         	}
-			}
+			FPT_busMstrDataXferStart(port, currSCCB);
+		}
+	}
 }
 
-
 /*---------------------------------------------------------------------
  *
  * Function: BusMaster Scatter Gather Data Transfer Start
@@ -5188,104 +4974,101 @@ static void FPT_dataXferProcessor(unsign
  * Description:
  *
  *---------------------------------------------------------------------*/
-static void FPT_busMstrSGDataXferStart(unsigned long p_port, struct sccb * pcurrSCCB)
+static void FPT_busMstrSGDataXferStart(unsigned long p_port,
+				       struct sccb *pcurrSCCB)
 {
-   unsigned long count,addr,tmpSGCnt;
-   unsigned int sg_index;
-   unsigned char sg_count, i;
-   unsigned long reg_offset;
-
-
-   if (pcurrSCCB->Sccb_XferState & F_HOST_XFER_DIR) {
-
-      count =  ((unsigned long) HOST_RD_CMD)<<24;
-      }
-
-   else {
-      count =  ((unsigned long) HOST_WRT_CMD)<<24;
-      }
-
-   sg_count = 0;
-   tmpSGCnt = 0;
-   sg_index = pcurrSCCB->Sccb_sgseg;
-   reg_offset = hp_aramBase;
-
-
-	i = (unsigned char) (RD_HARPOON(p_port+hp_page_ctrl) & ~(SGRAM_ARAM|SCATTER_EN));
+	unsigned long count, addr, tmpSGCnt;
+	unsigned int sg_index;
+	unsigned char sg_count, i;
+	unsigned long reg_offset;
 
+	if (pcurrSCCB->Sccb_XferState & F_HOST_XFER_DIR) {
 
-	WR_HARPOON(p_port+hp_page_ctrl, i);
-
-   while ((sg_count < (unsigned char)SG_BUF_CNT) &&
-      ((unsigned long)(sg_index * (unsigned int)SG_ELEMENT_SIZE) < pcurrSCCB->DataLength) ) {
+		count = ((unsigned long)HOST_RD_CMD) << 24;
+	}
 
-      tmpSGCnt += *(((unsigned long *)pcurrSCCB->DataPointer)+
-         (sg_index * 2));
+	else {
+		count = ((unsigned long)HOST_WRT_CMD) << 24;
+	}
 
-      count |= *(((unsigned long *)pcurrSCCB->DataPointer)+
-         (sg_index * 2));
+	sg_count = 0;
+	tmpSGCnt = 0;
+	sg_index = pcurrSCCB->Sccb_sgseg;
+	reg_offset = hp_aramBase;
 
-      addr = *(((unsigned long *)pcurrSCCB->DataPointer)+
-         ((sg_index * 2) + 1));
+	i = (unsigned char)(RD_HARPOON(p_port + hp_page_ctrl) &
+			    ~(SGRAM_ARAM | SCATTER_EN));
 
+	WR_HARPOON(p_port + hp_page_ctrl, i);
 
-      if ((!sg_count) && (pcurrSCCB->Sccb_SGoffset)) {
+	while ((sg_count < (unsigned char)SG_BUF_CNT) &&
+	       ((unsigned long)(sg_index * (unsigned int)SG_ELEMENT_SIZE) <
+		pcurrSCCB->DataLength)) {
 
-         addr += ((count & 0x00FFFFFFL) - pcurrSCCB->Sccb_SGoffset);
-         count = (count & 0xFF000000L) | pcurrSCCB->Sccb_SGoffset;
+		tmpSGCnt += *(((unsigned long *)pcurrSCCB->DataPointer) +
+			      (sg_index * 2));
 
-         tmpSGCnt = count & 0x00FFFFFFL;
-         }
+		count |= *(((unsigned long *)pcurrSCCB->DataPointer) +
+			   (sg_index * 2));
 
-      WR_HARP32(p_port,reg_offset,addr);
-      reg_offset +=4;
+		addr = *(((unsigned long *)pcurrSCCB->DataPointer) +
+			 ((sg_index * 2) + 1));
 
-      WR_HARP32(p_port,reg_offset,count);
-      reg_offset +=4;
+		if ((!sg_count) && (pcurrSCCB->Sccb_SGoffset)) {
 
-      count &= 0xFF000000L;
-      sg_index++;
-      sg_count++;
+			addr +=
+			    ((count & 0x00FFFFFFL) - pcurrSCCB->Sccb_SGoffset);
+			count =
+			    (count & 0xFF000000L) | pcurrSCCB->Sccb_SGoffset;
 
-      } /*End While */
+			tmpSGCnt = count & 0x00FFFFFFL;
+		}
 
-   pcurrSCCB->Sccb_XferCnt = tmpSGCnt;
+		WR_HARP32(p_port, reg_offset, addr);
+		reg_offset += 4;
 
-   WR_HARPOON(p_port+hp_sg_addr,(sg_count<<4));
+		WR_HARP32(p_port, reg_offset, count);
+		reg_offset += 4;
 
-   if (pcurrSCCB->Sccb_XferState & F_HOST_XFER_DIR) {
+		count &= 0xFF000000L;
+		sg_index++;
+		sg_count++;
 
-      WR_HARP32(p_port,hp_xfercnt_0,tmpSGCnt);
+	}			/*End While */
 
+	pcurrSCCB->Sccb_XferCnt = tmpSGCnt;
 
-      WR_HARPOON(p_port+hp_portctrl_0,(DMA_PORT | SCSI_PORT | SCSI_INBIT));
-      WR_HARPOON(p_port+hp_scsisig, S_DATAI_PH);
-      }
+	WR_HARPOON(p_port + hp_sg_addr, (sg_count << 4));
 
-   else {
+	if (pcurrSCCB->Sccb_XferState & F_HOST_XFER_DIR) {
 
+		WR_HARP32(p_port, hp_xfercnt_0, tmpSGCnt);
 
-      if ((!(RD_HARPOON(p_port+hp_synctarg_0) & NARROW_SCSI)) &&
-         (tmpSGCnt & 0x000000001))
-         {
+		WR_HARPOON(p_port + hp_portctrl_0,
+			   (DMA_PORT | SCSI_PORT | SCSI_INBIT));
+		WR_HARPOON(p_port + hp_scsisig, S_DATAI_PH);
+	}
 
-         pcurrSCCB->Sccb_XferState |= F_ODD_BALL_CNT;
-         tmpSGCnt--;
-         }
+	else {
 
+		if ((!(RD_HARPOON(p_port + hp_synctarg_0) & NARROW_SCSI)) &&
+		    (tmpSGCnt & 0x000000001)) {
 
-      WR_HARP32(p_port,hp_xfercnt_0,tmpSGCnt);
+			pcurrSCCB->Sccb_XferState |= F_ODD_BALL_CNT;
+			tmpSGCnt--;
+		}
 
-      WR_HARPOON(p_port+hp_portctrl_0,(SCSI_PORT | DMA_PORT | DMA_RD));
-      WR_HARPOON(p_port+hp_scsisig, S_DATAO_PH);
-      }
+		WR_HARP32(p_port, hp_xfercnt_0, tmpSGCnt);
 
+		WR_HARPOON(p_port + hp_portctrl_0,
+			   (SCSI_PORT | DMA_PORT | DMA_RD));
+		WR_HARPOON(p_port + hp_scsisig, S_DATAO_PH);
+	}
 
-   WR_HARPOON(p_port+hp_page_ctrl, (unsigned char) (i | SCATTER_EN));
+	WR_HARPOON(p_port + hp_page_ctrl, (unsigned char)(i | SCATTER_EN));
 
 }
 
-
 /*---------------------------------------------------------------------
  *
  * Function: BusMaster Data Transfer Start
@@ -5293,47 +5076,49 @@ static void FPT_busMstrSGDataXferStart(u
  * Description: 
  *
  *---------------------------------------------------------------------*/
-static void FPT_busMstrDataXferStart(unsigned long p_port, struct sccb * pcurrSCCB)
+static void FPT_busMstrDataXferStart(unsigned long p_port,
+				     struct sccb *pcurrSCCB)
 {
-   unsigned long addr,count;
+	unsigned long addr, count;
 
-   if (!(pcurrSCCB->Sccb_XferState & F_AUTO_SENSE)) {
+	if (!(pcurrSCCB->Sccb_XferState & F_AUTO_SENSE)) {
 
-      count = pcurrSCCB->Sccb_XferCnt;
+		count = pcurrSCCB->Sccb_XferCnt;
 
-      addr = (unsigned long) pcurrSCCB->DataPointer + pcurrSCCB->Sccb_ATC;
-      }
-
-   else {
-      addr = pcurrSCCB->SensePointer;
-      count = pcurrSCCB->RequestSenseLength;
+		addr =
+		    (unsigned long)pcurrSCCB->DataPointer + pcurrSCCB->Sccb_ATC;
+	}
 
-      }
+	else {
+		addr = pcurrSCCB->SensePointer;
+		count = pcurrSCCB->RequestSenseLength;
 
-   HP_SETUP_ADDR_CNT(p_port,addr,count);
+	}
 
+	HP_SETUP_ADDR_CNT(p_port, addr, count);
 
-   if (pcurrSCCB->Sccb_XferState & F_HOST_XFER_DIR) {
+	if (pcurrSCCB->Sccb_XferState & F_HOST_XFER_DIR) {
 
-      WR_HARPOON(p_port+hp_portctrl_0,(DMA_PORT | SCSI_PORT | SCSI_INBIT));
-      WR_HARPOON(p_port+hp_scsisig, S_DATAI_PH);
+		WR_HARPOON(p_port + hp_portctrl_0,
+			   (DMA_PORT | SCSI_PORT | SCSI_INBIT));
+		WR_HARPOON(p_port + hp_scsisig, S_DATAI_PH);
 
-      WR_HARPOON(p_port+hp_xfer_cmd,
-         (XFER_DMA_HOST | XFER_HOST_AUTO | XFER_DMA_8BIT));
-      }
+		WR_HARPOON(p_port + hp_xfer_cmd,
+			   (XFER_DMA_HOST | XFER_HOST_AUTO | XFER_DMA_8BIT));
+	}
 
-   else {
+	else {
 
-      WR_HARPOON(p_port+hp_portctrl_0,(SCSI_PORT | DMA_PORT | DMA_RD));
-      WR_HARPOON(p_port+hp_scsisig, S_DATAO_PH);
+		WR_HARPOON(p_port + hp_portctrl_0,
+			   (SCSI_PORT | DMA_PORT | DMA_RD));
+		WR_HARPOON(p_port + hp_scsisig, S_DATAO_PH);
 
-      WR_HARPOON(p_port+hp_xfer_cmd,
-         (XFER_HOST_DMA | XFER_HOST_AUTO | XFER_DMA_8BIT));
+		WR_HARPOON(p_port + hp_xfer_cmd,
+			   (XFER_HOST_DMA | XFER_HOST_AUTO | XFER_DMA_8BIT));
 
-      }
+	}
 }
 
-
 /*---------------------------------------------------------------------
  *
  * Function: BusMaster Timeout Handler
@@ -5348,35 +5133,36 @@ static void FPT_busMstrDataXferStart(uns
  *---------------------------------------------------------------------*/
 static unsigned char FPT_busMstrTimeOut(unsigned long p_port)
 {
-   unsigned long timeout;
+	unsigned long timeout;
 
-   timeout = LONG_WAIT;
+	timeout = LONG_WAIT;
 
-   WR_HARPOON(p_port+hp_sys_ctrl, HALT_MACH);
+	WR_HARPOON(p_port + hp_sys_ctrl, HALT_MACH);
 
-   while ((!(RD_HARPOON(p_port+hp_ext_status) & CMD_ABORTED)) && timeout--) {}
+	while ((!(RD_HARPOON(p_port + hp_ext_status) & CMD_ABORTED))
+	       && timeout--) {
+	}
 
-   
-   
-   if (RD_HARPOON(p_port+hp_ext_status) & BM_CMD_BUSY) {
-      WR_HARPOON(p_port+hp_sys_ctrl, HARD_ABORT);
+	if (RD_HARPOON(p_port + hp_ext_status) & BM_CMD_BUSY) {
+		WR_HARPOON(p_port + hp_sys_ctrl, HARD_ABORT);
 
-      timeout = LONG_WAIT;
-      while ((RD_HARPOON(p_port+hp_ext_status) & BM_CMD_BUSY) && timeout--) {}
-      }
+		timeout = LONG_WAIT;
+		while ((RD_HARPOON(p_port + hp_ext_status) & BM_CMD_BUSY)
+		       && timeout--) {
+		}
+	}
 
-   RD_HARPOON(p_port+hp_int_status);           /*Clear command complete */
+	RD_HARPOON(p_port + hp_int_status);	/*Clear command complete */
 
-   if (RD_HARPOON(p_port+hp_ext_status) & BM_CMD_BUSY) {
-      return(1);
-      }
+	if (RD_HARPOON(p_port + hp_ext_status) & BM_CMD_BUSY) {
+		return (1);
+	}
 
-   else {
-      return(0);
-      }
+	else {
+		return (0);
+	}
 }
 
-
 /*---------------------------------------------------------------------
  *
  * Function: Host Data Transfer Abort
